<?php
namespace Service\Log;


use Doctrine\ORM\EntityManager;
use Zeedhi\DevOps\Model\Projectmanagement\Entities\Allocation;
use Zeedhi\DevOps\Model\Projectmanagement\EntitiesInterface\Log\ProjectLogInterface;
use Zeedhi\DevOps\Model\Projectmanagement\Entities;

class ProjectLog {
    protected $entityManager;

    const LOG_TYPE_UPDATE = 'UPDATE';
    const LOG_TYPE_INSERT = 'INSERT';
    const LOG_TYPE_DELETE = 'DELETE';

    public function __construct(EntityManager $entityManager){
        $this->entityManager = $entityManager;
    }

    public function createLogUpdate(ProjectLogInterface $entity,$oldValue = null,$newValue = null,$columnName = null){
        $projectLog = new Entities\ProjectLog();
        $projectLog->setProject($entity->getProject()->getId());
        if($entity->getTask()){
            $projectLog->setTask($entity->getTask()->getId());
        }
        $projectLog->setColumnName($columnName);
        $projectLog->setTableName($entity->getTableName());
        if($columnName == 'STATUS' AND $newValue == 'D'){
            $projectLog->setLogType(self::LOG_TYPE_DELETE);
            $projectLog->setOldValue(null);
            $projectLog->setNewValue(null);

        }else{
            $projectLog->setOldValue($oldValue);
            $projectLog->setNewValue($newValue);
            $projectLog->setLogType(self::LOG_TYPE_UPDATE);
        }
        $this->entityManager->persist($projectLog);
    }
    public function createLogInsert(ProjectLogInterface $entity){

        $projectLog = new Entities\ProjectLog();
        $projectLog->setProject($entity->getProject()->getId());
        if($entity->getTask()){
            $projectLog->setTask($entity->getTask()->getId());
        }
        $projectLog->setTableName($entity->getTableName());
        $projectLog->setLogType(self::LOG_TYPE_INSERT);
        $this->entityManager->persist($projectLog);
    }
    public function createLogInsertAllocation(Entities\Allocation $entity){

        $projectLog = new Entities\ProjectLog();
        $projectLog->setResource($entity->getResource()->getId());
        $projectLog->setTask($entity->getTask()->getId());
        $projectLog->setProject($entity->getTask()->getProject()->getId());
        $projectLog->setTableName($entity->getTableName());
        $projectLog->setLogType(self::LOG_TYPE_INSERT);
        $this->entityManager->persist($projectLog);
    }
    public function createLogRemoveAllocation(Entities\Allocation $entity){

        $projectLog = new Entities\ProjectLog();
        $projectLog->setResource($entity->getResource()->getId());
        $projectLog->setTask($entity->getTask()->getId());
        $projectLog->setProject($entity->getTask()->getProject()->getId());
        $projectLog->setTableName($entity->getTableName());
        $projectLog->setLogType(self::LOG_TYPE_DELETE);
        $this->entityManager->persist($projectLog);
    }
} 